## iwyu 3.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(include-what-you-use)

if( CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR )
  message(STATUS "IWYU out-of-tree configuration")

  if( NOT DEFINED LLVM_PATH )
    message(FATAL_ERROR "LLVM_PATH must be provided using -DLLVM_PATH=<path to llvm package root>")
  endif()

  link_directories(${LLVM_PATH}/lib)
  include_directories(${LLVM_PATH}/include)

  add_definitions(
    -D__STDC_LIMIT_MACROS
    -D__STDC_CONSTANT_MACROS
  )

  if( MSVC )
    # Adjust MSVC warning levels.
    add_definitions(
      # Ignore security warnings for standard functions.
      -D_CRT_SECURE_NO_WARNINGS
      -D_SCL_SECURE_NO_WARNINGS

      # Disabled warnings.
      -wd4146 # Suppress 'unary minus operator applied to unsigned type, result still unsigned'
      -wd4244 # Suppress ''argument' : conversion from 'type1' to 'type2', possible loss of data'
      -wd4291 # Suppress ''declaration' : no matching operator delete found; memory will not be freed if initialization throws an exception'
      -wd4345 # Suppress 'behavior change: an object of POD type constructed with an initializer of the form () will be default-initialized'
      -wd4355 # Suppress ''this' : used in base member initializer list'
      -wd4624 # Suppress ''derived class' : destructor could not be generated because a base class destructor is inaccessible'
      -wd4800 # Suppress ''type' : forcing value to bool 'true' or 'false' (performance warning)'

      # Promoted warnings.
      -w14062 # Promote 'enumerator in switch of enum is not handled' to level 1 warning.

      # Promoted warnings to errors.
      -we4238 # Promote 'nonstandard extension used : class rvalue used as lvalue' to error.
    )
  endif()
else()
  message(STATUS "IWYU in-tree configuration")
endif()

add_executable(include-what-you-use
  iwyu.cc
  iwyu_ast_util.cc
  iwyu_cache.cc
  iwyu_driver.cc
  iwyu_getopt.cc
  iwyu_globals.cc
  iwyu_include_picker.cc
  iwyu_lexer_utils.cc
  iwyu_location_util.cc
  iwyu_output.cc
  iwyu_path_util.cc
  iwyu_preprocessor.cc
  iwyu_verrs.cc
)

if( MSVC )
  # Put project in solution folder
  set_target_properties(include-what-you-use
    PROPERTIES FOLDER "Clang executables"
  )
else()
  # Disable RTTI to be compatible with LLVM/Clang libraries.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
endif()

# Clang dependencies.
target_link_libraries(include-what-you-use
  clangFrontend
  clangSerialization
  clangDriver
  clangParse
  clangSema
  clangAnalysis
  clangAST
  clangBasic
  clangEdit
  clangLex
)

# LLVM dependencies.
target_link_libraries(include-what-you-use
  LLVMipo
  LLVMScalarOpts
  LLVMInstCombine
  LLVMTransformUtils
  LLVMipa
  LLVMAnalysis
  LLVMTarget
  LLVMMC
  LLVMMCParser
  LLVMCore
  LLVMSupport
  LLVMBitReader
)

# Platform dependencies.
if( WIN32 )
  target_link_libraries(include-what-you-use
    shlwapi
  )
else()
  target_link_libraries(include-what-you-use
    pthread
    dl
  )
endif()

install(TARGETS include-what-you-use
  RUNTIME DESTINATION bin)

=== Makefile ===
##===- tools/include-what-you-use/Makefile -----------------*- Makefile -*-===##
#
#                     The LLVM Compiler Infrastructure
#
# This file is distributed under the University of Illinois Open Source
# License. See LICENSE.TXT for details.
#
##===----------------------------------------------------------------------===##

# If you get compile errors while building this, it may be that
# top-of-tree clang has changed its internal API a bit since the last
# iwyu commit.  One way to solve this is to use 'svn log' to figure
# out when the last commit to the include-what-you-use tree was (or
# visit http://code.google.com/p/include-what-you-use/source/list),
# and then sync clang and llvm to the revision they had at that time.

CLANG_LEVEL := ../..

TOOLNAME = include-what-you-use
NO_INSTALL = 1

# No plugins, optimize startup time.
TOOL_NO_EXPORTS = 1

include $(CLANG_LEVEL)/../../Makefile.config
LINK_COMPONENTS = $(TARGETS_TO_BUILD) asmparser bitreader ipo
USEDLIBS = clangFrontend.a clangSerialization.a clangDriver.a clangParse.a \
           clangSema.a clangAnalysis.a clangAST.a clangEdit.a clangLex.a \
           clangBasic.a

include $(CLANG_LEVEL)/Makefile

# Link with import library for shlwapi.dll on Windows.
ifneq (,$(filter $(HOST_OS), Cygwin MingW))
  LIBS += -lshlwapi
endif

check-iwyu:: all
	./run_iwyu_tests.py
	./fix_includes_test.py

=== debian/changelog ===
iwyu (3.3-4) unstable; urgency=medium

  * Make iwyu co-installable with clang 3.5 (Closes: #734900)
  * Standards-Version updated to 3.9.5
  * Switch the default clang to 3.4

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 15 Jan 2014 10:14:58 +0100

iwyu (3.3-3) unstable; urgency=low

  * Remove the trailing debian/ from debian/control
  * Also ship fix_include in iwyu. It applies the changes (Closes: #728590)
  * Fix the clean of the package
  * Remove the "SEE ALSO" section from the manpage (Closes: #722225)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 04 Nov 2013 09:02:17 +0100

iwyu (3.3-2) unstable; urgency=low

  * clang is a mandatory dependency (Closes: #722132)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 08 Sep 2013 12:33:59 +0200

iwyu (3.3-1) unstable; urgency=low

  * Initial release (Closes: #721267)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 29 Aug 2013 17:16:23 +0200

=== debian/control ===
Source: iwyu
Section: devel
Priority: extra
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 8.0.0), cmake, libclang-3.3-dev, llvm-3.3-dev,
 help2man
Standards-Version: 3.9.5
Homepage: http://code.google.com/p/include-what-you-use/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/iwyu/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/iwyu/trunk/

Package: iwyu
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, clang-3.3 | clang-3.4 | clang-3.5, python
Description: Analyze #includes in C and C++ source files
 "Include what you use" means this: for every symbol (type, function variable,
 or macro) that you use in foo.cc, either foo.cc or foo.h should #include a .h
 file that exports the declaration of that symbol. The include-what-you-use
 tool is a program that can be built with the clang libraries in order to
 analyze #includes of source files to find include-what-you-use violations,
 and suggest fixes for them.
 .
 The main goal of include-what-you-use is to remove superfluous #includes.
 It does this both by figuring out what #includes are not actually needed for
 this file (for both .cc and .h files), and replacing #includes with
 forward-declares when possible.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

TARGET_BUILD=iwyu-build
VERSION=$(shell dpkg-parsechangelog |grep "^Version:"|sed -e "s|Version: \(.*\)|\1|")

%:
	dh $@ --buildsystem=cmake --builddirectory=$(TARGET_BUILD)

override_dh_auto_configure:
	dh_auto_configure -- -DLLVM_PATH=/usr/lib/llvm-3.3/

override_dh_auto_build:
	dh_auto_build
	help2man --no-info --version-string "$(VERSION)" -n "Analyze #includes in C and C++ source files" $(TARGET_BUILD)/include-what-you-use > $(TARGET_BUILD)/include-what-you-use.1
	cd $(TARGET_BUILD) && ln -s include-what-you-use.1 iwyu.1 && \
	cp ../fix_includes.py fix_include

override_dh_auto_clean:
	rm -rf $(TARGET_BUILD)

## iwyu 3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -40,6 +40,10 @@
       -we4238 # Promote 'nonstandard extension used : class rvalue used as lvalue' to error.
     )
   endif()
+
+  if( CMAKE_SYSTEM_NAME MATCHES "Darwin" )
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
+  endif()
 else()
   message(STATUS "IWYU in-tree configuration")
 endif()
@@ -61,6 +65,11 @@
 )
 
 if( MSVC )
+  # Disable warnings for IWYU
+  add_definitions(
+    -wd4722 # Suppress ''destructor'' : destructor never returns, potential memory leak
+  )
+
   # Put project in solution folder
   set_target_properties(include-what-you-use
     PROPERTIES FOLDER "Clang executables"
@@ -86,6 +95,11 @@
 
 # LLVM dependencies.
 target_link_libraries(include-what-you-use
+  LLVMX86AsmParser # MC, MCParser, Support, X86Desc, X86Info
+  LLVMX86Desc # MC, Support, X86AsmPrinter, X86Info
+  LLVMX86AsmPrinter # MC, Support, X86Utils
+  LLVMX86Info # MC, Support, Target
+  LLVMX86Utils # Core, Support
   LLVMipo
   LLVMScalarOpts
   LLVMInstCombine
@@ -93,11 +107,13 @@
   LLVMipa
   LLVMAnalysis
   LLVMTarget
-  LLVMMC
-  LLVMMCParser
-  LLVMCore
+  LLVMMC # Object, Support
+  LLVMMCParser # MC, Support
+  LLVMObject # Support
+  LLVMCore # Support
   LLVMSupport
   LLVMBitReader
+  LLVMOption
 )
 
 # Platform dependencies.
@@ -109,6 +125,7 @@
   target_link_libraries(include-what-you-use
     pthread
     dl
+    curses
   )
 endif()

=== Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 TOOL_NO_EXPORTS = 1
 
 include $(CLANG_LEVEL)/../../Makefile.config
-LINK_COMPONENTS = $(TARGETS_TO_BUILD) asmparser bitreader ipo
+LINK_COMPONENTS = $(TARGETS_TO_BUILD) asmparser bitreader ipo option
 USEDLIBS = clangFrontend.a clangSerialization.a clangDriver.a clangParse.a \
            clangSema.a clangAnalysis.a clangAST.a clangEdit.a clangLex.a \
            clangBasic.a

=== debian/changelog ===
iwyu (3.4-1) unstable; urgency=medium

  * New upstream release
  * Add libncurses5-dev as a build deps
  * Add a watch file

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 06 May 2014 17:11:05 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: extra
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 8.0.0), cmake, libclang-3.3-dev, llvm-3.3-dev,
- help2man
+Build-Depends: debhelper (>= 8.0.0), cmake, libclang-3.4-dev, llvm-3.4-dev,
+ help2man, libncurses5-dev
 Standards-Version: 3.9.5
 Homepage: http://code.google.com/p/include-what-you-use/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/iwyu/trunk/

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	dh $@ --buildsystem=cmake --builddirectory=$(TARGET_BUILD)
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DLLVM_PATH=/usr/lib/llvm-3.3/
+	dh_auto_configure -- -DLLVM_PATH=/usr/lib/llvm-3.4/
 
 override_dh_auto_build:
 	dh_auto_build

=== debian/watch ===
version=3
https://code.google.com/p/include-what-you-use/ \
http://include-what-you-use.com/downloads/include-what-you-use-(.*).src.tar.gz

## iwyu 3.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,12 +5,27 @@
 if( CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR )
   message(STATUS "IWYU out-of-tree configuration")
 
-  if( NOT DEFINED LLVM_PATH )
-    message(FATAL_ERROR "LLVM_PATH must be provided using -DLLVM_PATH=<path to llvm package root>")
+  if( DEFINED LLVM_PATH )
+    set(IWYU_LLVM_ROOT_PATH ${LLVM_PATH})
+    message(WARNING "LLVM_PATH is deprecated, use IWYU_LLVM_ROOT_PATH instead.")
   endif()
 
-  link_directories(${LLVM_PATH}/lib)
-  include_directories(${LLVM_PATH}/include)
+  if( DEFINED IWYU_LLVM_INCLUDE_PATH AND DEFINED IWYU_LLVM_LIB_PATH )
+    # User provided include/lib paths, fall through
+  elseif ( DEFINED IWYU_LLVM_ROOT_PATH )
+    # Synthesize include/lib relative to a root.
+    set(IWYU_LLVM_INCLUDE_PATH ${IWYU_LLVM_ROOT_PATH}/include)
+    set(IWYU_LLVM_LIB_PATH ${IWYU_LLVM_ROOT_PATH}/lib)
+  else()
+    # If none provided, fail.
+    message(FATAL_ERROR
+      "Don't know how to find LLVM headers/libraries. "
+      "Use -DIWYU_LLVM_ROOT_PATH=/xyz or both "
+      "-DIWYU_LLVM_INCLUDE_PATH=/xyz/include and -DIWYU_LLVM_LIB_PATH=/xyz/lib")
+  endif()
+
+  include_directories(${IWYU_LLVM_INCLUDE_PATH})
+  link_directories(${IWYU_LLVM_LIB_PATH})
 
   add_definitions(
     -D__STDC_LIMIT_MACROS
@@ -48,6 +63,16 @@
   message(STATUS "IWYU in-tree configuration")
 endif()
 
+# Pick up SVN revision so we can report it
+# in version information.
+include(FindSubversion)
+if( Subversion_FOUND AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.svn" )
+  Subversion_WC_INFO(${CMAKE_CURRENT_SOURCE_DIR} IWYU)
+endif()
+add_definitions(
+  -DIWYU_SVN_REVISION="${IWYU_WC_REVISION}"
+)
+
 add_executable(include-what-you-use
   iwyu.cc
   iwyu_ast_util.cc
@@ -65,9 +90,10 @@
 )
 
 if( MSVC )
-  # Disable warnings for IWYU
+  # Disable warnings for IWYU, and disable exceptions in MSVC's STL.
   add_definitions(
     -wd4722 # Suppress ''destructor'' : destructor never returns, potential memory leak
+    -D_HAS_EXCEPTIONS=0
   )
 
   # Put project in solution folder
@@ -75,8 +101,8 @@
     PROPERTIES FOLDER "Clang executables"
   )
 else()
-  # Disable RTTI to be compatible with LLVM/Clang libraries.
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
+  # Disable RTTI, use C++11 to be compatible with LLVM/Clang libraries.
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti -std=c++11")
 endif()
 
 # Clang dependencies.
@@ -95,11 +121,14 @@
 
 # LLVM dependencies.
 target_link_libraries(include-what-you-use
-  LLVMX86AsmParser # MC, MCParser, Support, X86Desc, X86Info
-  LLVMX86Desc # MC, Support, X86AsmPrinter, X86Info
+  LLVMX86AsmParser # MC, MCParser, Support, X86CodeGen, X86Desc, X86Info
+  LLVMX86CodeGen # Analysis, AsmPrinter, CodeGen, Core, MC, Support, Target, 
+                 # X86AsmPrinter, X86Desc, X86Info, X86Utils
+  LLVMX86Desc # MC, MCDisassembler, Object, Support, X86AsmPrinter, X86Info
   LLVMX86AsmPrinter # MC, Support, X86Utils
-  LLVMX86Info # MC, Support, Target
+  LLVMX86Info # Support
   LLVMX86Utils # Core, Support
+  LLVMCodeGen # Analysis, Core, MC, Scalar, Support, Target, TransformUtils
   LLVMipo
   LLVMScalarOpts
   LLVMInstCombine
@@ -107,26 +136,36 @@
   LLVMipa
   LLVMAnalysis
   LLVMTarget
+  LLVMOption # Support
+  LLVMMCDisassembler # MC, Support
+  LLVMMCParser # MC, Support
   LLVMMC # Object, Support
-  LLVMMCParser # MC, Support
-  LLVMObject # Support
+  LLVMObject # BitReader, Core, Support
+  LLVMBitReader # Core, Support
   LLVMCore # Support
   LLVMSupport
-  LLVMBitReader
-  LLVMOption
 )
 
 # Platform dependencies.
-if( WIN32 )
+if( CMAKE_SYSTEM_NAME MATCHES "Windows" )
   target_link_libraries(include-what-you-use
     shlwapi
   )
 else()
+  # POSIX
+  include(FindCurses)
   target_link_libraries(include-what-you-use
     pthread
-    dl
-    curses
+    z
+    ${CURSES_LIBRARIES}
   )
+
+  # Only Linux targets need dl for dynamic linking.
+  if( CMAKE_SYSTEM_NAME MATCHES "Linux" )
+    target_link_libraries(include-what-you-use
+      dl
+    )
+  endif()
 endif()
 
 install(TARGETS include-what-you-use

=== Makefile ===
--- 
+++ 
@@ -35,6 +35,12 @@
   LIBS += -lshlwapi
 endif
 
+# Provide SVN revision for version string like in clang/lib/Basic/Makefile.
+IWYU_SVN_REVISION := $(strip \
+        $(shell $(LLVM_SRC_ROOT)/utils/GetSourceVersion $(PROJ_SRC_DIR)))
+
+CPP.Defines += -DIWYU_SVN_REVISION='"$(IWYU_SVN_REVISION)"'
+
 check-iwyu:: all
 	./run_iwyu_tests.py
 	./fix_includes_test.py

=== debian/changelog ===
iwyu (3.6-1) unstable; urgency=low

  * Team upload (Sylvestre prepared the upload)
  * New upstream release (Closes: #795499)

 -- Michael Vogt <mvo@debian.org>  Fri, 14 Aug 2015 20:00:47 +0200

ciwyu (3.5-1) unstable; urgency=medium

  * Upload to unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 16 Jun 2015 11:14:00 +0200

iwyu (3.5-1~exp1) experimental; urgency=medium

  * New upstream release
  * Switch to llvm/clang 3.5
  * Standards-Version updated to 3.9.6

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 30 Dec 2014 14:32:11 +0100

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,16 @@
 Priority: extra
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 8.0.0), cmake, libclang-3.4-dev, llvm-3.4-dev,
- help2man, libncurses5-dev
-Standards-Version: 3.9.5
-Homepage: http://code.google.com/p/include-what-you-use/
+Build-Depends: debhelper (>= 8.0.0), cmake, libclang-3.6-dev, llvm-3.6-dev,
+ help2man, libncurses5-dev, zlib1g-dev
+Standards-Version: 3.9.6
+Homepage: http://include-what-you-use.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/iwyu/trunk/
 Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/iwyu/trunk/
 
 Package: iwyu
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, clang-3.3 | clang-3.4 | clang-3.5, python
+Depends: ${shlibs:Depends}, ${misc:Depends}, clang-3.3 | clang-3.4 | clang-3.5 | clang-3.6 | clang-3.7 | clang-3.8, python
 Description: Analyze #includes in C and C++ source files
  "Include what you use" means this: for every symbol (type, function variable,
  or macro) that you use in foo.cc, either foo.cc or foo.h should #include a .h

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	dh $@ --buildsystem=cmake --builddirectory=$(TARGET_BUILD)
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DLLVM_PATH=/usr/lib/llvm-3.4/
+	dh_auto_configure -- -DLLVM_PATH=/usr/lib/llvm-3.6/
 
 override_dh_auto_build:
 	dh_auto_build

## iwyu 3.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -63,15 +63,15 @@
   message(STATUS "IWYU in-tree configuration")
 endif()
 
-# Pick up SVN revision so we can report it
-# in version information.
-include(FindSubversion)
-if( Subversion_FOUND AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.svn" )
-  Subversion_WC_INFO(${CMAKE_CURRENT_SOURCE_DIR} IWYU)
+# Pick up Git revision so we can report it in version information.
+include(FindGit)
+if( GIT_FOUND )
+  execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
+    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+    OUTPUT_VARIABLE IWYU_GIT_REV
+    OUTPUT_STRIP_TRAILING_WHITESPACE)
 endif()
-add_definitions(
-  -DIWYU_SVN_REVISION="${IWYU_WC_REVISION}"
-)
+add_definitions(-DIWYU_GIT_REV="${IWYU_GIT_REV}")
 
 add_executable(include-what-you-use
   iwyu.cc
@@ -134,8 +134,8 @@
   LLVMInstCombine
   LLVMTransformUtils
   LLVMipa
-  LLVMAnalysis
-  LLVMTarget
+  LLVMTarget # Analysis, MC, Core, Support
+  LLVMAnalysis # Core, Support
   LLVMOption # Support
   LLVMMCDisassembler # MC, Support
   LLVMMCParser # MC, Support
@@ -168,5 +168,5 @@
   endif()
 endif()
 
-install(TARGETS include-what-you-use
-  RUNTIME DESTINATION bin)
+install(TARGETS include-what-you-use RUNTIME DESTINATION bin)
+install(PROGRAMS fix_includes.py iwyu_tool.py DESTINATION bin)

=== Makefile ===
--- 
+++ 
@@ -35,11 +35,11 @@
   LIBS += -lshlwapi
 endif
 
-# Provide SVN revision for version string like in clang/lib/Basic/Makefile.
-IWYU_SVN_REVISION := $(strip \
+# Provide Git revision for version string like in clang/lib/Basic/Makefile.
+IWYU_GIT_REV := $(strip \
         $(shell $(LLVM_SRC_ROOT)/utils/GetSourceVersion $(PROJ_SRC_DIR)))
 
-CPP.Defines += -DIWYU_SVN_REVISION='"$(IWYU_SVN_REVISION)"'
+CPP.Defines += -DIWYU_GIT_REV='"$(IWYU_GIT_REV)"'
 
 check-iwyu:: all
 	./run_iwyu_tests.py

=== debian/changelog ===
iwyu (3.7-1) unstable; urgency=medium

  * New upstream release
  * Remove old dep from the list (clang-3.3 | clang-3.4)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 26 Dec 2015 23:56:01 +0100

iwyu (3.6-2) unstable; urgency=medium

  * Fix the FTBFS under kfreebsd
    Thanks to Steven Chamberlain for the patch
    (Closes: #794563)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 08 Sep 2015 08:48:51 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 8.0.0), cmake, libclang-3.6-dev, llvm-3.6-dev,
+Build-Depends: debhelper (>= 8.0.0), cmake, libclang-3.7-dev, llvm-3.7-dev,
  help2man, libncurses5-dev, zlib1g-dev
 Standards-Version: 3.9.6
 Homepage: http://include-what-you-use.org/
@@ -12,7 +12,7 @@
 
 Package: iwyu
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, clang-3.3 | clang-3.4 | clang-3.5 | clang-3.6 | clang-3.7 | clang-3.8, python
+Depends: ${shlibs:Depends}, ${misc:Depends}, clang-3.5 | clang-3.6 | clang-3.7 | clang-3.8, python
 Description: Analyze #includes in C and C++ source files
  "Include what you use" means this: for every symbol (type, function variable,
  or macro) that you use in foo.cc, either foo.cc or foo.h should #include a .h

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	dh $@ --buildsystem=cmake --builddirectory=$(TARGET_BUILD)
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DLLVM_PATH=/usr/lib/llvm-3.6/
+	dh_auto_configure -- -DLLVM_PATH=/usr/lib/llvm-3.7/
 
 override_dh_auto_build:
 	dh_auto_build

## iwyu 3.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,9 @@
 cmake_minimum_required(VERSION 2.8)
+
+if( POLICY CMP0048 )
+  # Silence CMP0048 warning about missing project VERSION.
+  cmake_policy(SET CMP0048 NEW)
+endif()
 
 project(include-what-you-use)
 
@@ -56,7 +61,7 @@
     )
   endif()
 
-  if( CMAKE_SYSTEM_NAME MATCHES "Darwin" )
+  if( APPLE )
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
   endif()
 else()
@@ -65,11 +70,14 @@
 
 # Pick up Git revision so we can report it in version information.
 include(FindGit)
-if( GIT_FOUND )
+if( GIT_FOUND AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git" )
   execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
     WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
     OUTPUT_VARIABLE IWYU_GIT_REV
     OUTPUT_STRIP_TRAILING_WHITESPACE)
+else()
+  message(STATUS "Warning: IWYU Git version info not found, DO NOT release "
+                 "from this build tree!")
 endif()
 add_definitions(-DIWYU_GIT_REV="${IWYU_GIT_REV}")
 
@@ -88,6 +96,11 @@
   iwyu_preprocessor.cc
   iwyu_verrs.cc
 )
+
+if( MINGW )
+  # Work around 'too many sections' error with MINGW/GCC
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wa,-mbig-obj")
+endif()
 
 if( MSVC )
   # Disable warnings for IWYU, and disable exceptions in MSVC's STL.
@@ -133,7 +146,6 @@
   LLVMScalarOpts
   LLVMInstCombine
   LLVMTransformUtils
-  LLVMipa
   LLVMTarget # Analysis, MC, Core, Support
   LLVMAnalysis # Core, Support
   LLVMOption # Support
@@ -147,25 +159,22 @@
 )
 
 # Platform dependencies.
-if( CMAKE_SYSTEM_NAME MATCHES "Windows" )
+if( WIN32 )
   target_link_libraries(include-what-you-use
     shlwapi
   )
-else()
-  # POSIX
+elseif( UNIX )
   include(FindCurses)
   target_link_libraries(include-what-you-use
     pthread
     z
     ${CURSES_LIBRARIES}
+    ${CMAKE_DL_LIBS}
   )
-
-  # Only Linux targets need dl for dynamic linking.
-  if( CMAKE_SYSTEM_NAME MATCHES "Linux" )
-    target_link_libraries(include-what-you-use
-      dl
-    )
-  endif()
+else()
+  message(WARNING
+    "Unknown system: ${CMAKE_SYSTEM_NAME}. "
+    "No platform link-dependencies added.")
 endif()
 
 install(TARGETS include-what-you-use RUNTIME DESTINATION bin)

=== debian/changelog ===
iwyu (3.8-1) unstable; urgency=medium

  * New upstream release
  * Switch to clang 3.8
  * Standards-Version to 3.9.8

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 25 Jun 2016 20:16:19 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: extra
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 8.0.0), cmake, libclang-3.7-dev, llvm-3.7-dev,
+Build-Depends: debhelper (>= 8.0.0), cmake, libclang-3.8-dev, llvm-3.8-dev,
  help2man, libncurses5-dev, zlib1g-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://include-what-you-use.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/iwyu/trunk/
 Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/iwyu/trunk/

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	dh $@ --buildsystem=cmake --builddirectory=$(TARGET_BUILD)
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DLLVM_PATH=/usr/lib/llvm-3.7/
+	dh_auto_configure -- -DLLVM_PATH=/usr/lib/llvm-3.8/
 
 override_dh_auto_build:
 	dh_auto_build

## iwyu 3.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.4.3)
 
 if( POLICY CMP0048 )
   # Silence CMP0048 warning about missing project VERSION.
@@ -152,6 +152,7 @@
   LLVMMCDisassembler # MC, Support
   LLVMMCParser # MC, Support
   LLVMMC # Object, Support
+  LLVMProfileData # Core, Support, Object
   LLVMObject # BitReader, Core, Support
   LLVMBitReader # Core, Support
   LLVMCore # Support
@@ -179,3 +180,7 @@
 
 install(TARGETS include-what-you-use RUNTIME DESTINATION bin)
 install(PROGRAMS fix_includes.py iwyu_tool.py DESTINATION bin)
+
+# Install mapping files
+file(GLOB MAPPING_FILES *.imp)
+install(FILES ${MAPPING_FILES} DESTINATION share/include-what-you-use)

=== debian/changelog ===
iwyu (3.9-2) unstable; urgency=medium

  * Rebuild to manage clang 3.9.1 (Closes: #849402)
    yes, this needs to be properly fixed and managed at runtime
  * Remove usr/bin/fix_includes.py to fix script-with-language-extension 
    (was already shipped under fix_includes anyway)
  * Rename usr/bin/iwyu_tool.py to usr/bin/iwyu_tool

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 26 Dec 2016 18:49:23 +0100

iwyu (3.9-1) unstable; urgency=medium

  * New upstream release
    (Closes: #828734)
  * Fix FTBFS on mips64el (Closes: #775435)
    Thanks to James Cowgill

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 10 Nov 2016 12:49:29 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 8.0.0), cmake, libclang-3.8-dev, llvm-3.8-dev,
+Build-Depends: debhelper (>= 8.0.0), cmake, libclang-3.9-dev, llvm-3.9-dev,
  help2man, libncurses5-dev, zlib1g-dev
 Standards-Version: 3.9.8
 Homepage: http://include-what-you-use.org/
@@ -12,7 +12,7 @@
 
 Package: iwyu
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, clang-3.5 | clang-3.6 | clang-3.7 | clang-3.8, python
+Depends: ${shlibs:Depends}, ${misc:Depends}, clang-3.5 | clang-3.6 | clang-3.7 | clang-3.8 | clang-3.9 | clang-4.0, python
 Description: Analyze #includes in C and C++ source files
  "Include what you use" means this: for every symbol (type, function variable,
  or macro) that you use in foo.cc, either foo.cc or foo.h should #include a .h

=== debian/rules ===
--- 
+++ 
@@ -6,12 +6,19 @@
 
 TARGET_BUILD=iwyu-build
 VERSION=$(shell dpkg-parsechangelog |grep "^Version:"|sed -e "s|Version: \(.*\)|\1|")
+DEB_BUILD_ARCH?=$(shell dpkg-architecture -qDEB_BUILD_ARCH)
+ADDITIONAL_CXX_FLAGS=""
+
+ifneq (,$(filter $(DEB_BUILD_ARCH),mips64el))
+	ADDITIONAL_CXX_FLAGS += -mxgot
+endif
 
 %:
 	dh $@ --buildsystem=cmake --builddirectory=$(TARGET_BUILD)
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DLLVM_PATH=/usr/lib/llvm-3.8/
+	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-3.9/
+
 
 override_dh_auto_build:
 	dh_auto_build
@@ -19,5 +26,12 @@
 	cd $(TARGET_BUILD) && ln -s include-what-you-use.1 iwyu.1 && \
 	cp ../fix_includes.py fix_include
 
+override_dh_auto_install:
+	dh_auto_install
+	cd debian/iwyu/usr/bin; \
+		rm -f fix_includes.py; \
+		mv iwyu_tool.py iwyu_tool
+
+
 override_dh_auto_clean:
 	rm -rf $(TARGET_BUILD)

## iwyu 4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,8 +45,10 @@
       -D_SCL_SECURE_NO_WARNINGS
 
       # Disabled warnings.
+      -wd4141 # Suppress ''modifier' : used more than once' (because of __forceinline combined with inline)
       -wd4146 # Suppress 'unary minus operator applied to unsigned type, result still unsigned'
       -wd4244 # Suppress ''argument' : conversion from 'type1' to 'type2', possible loss of data'
+      -wd4267 # Suppress ''var' : conversion from 'size_t' to 'type', possible loss of data'
       -wd4291 # Suppress ''declaration' : no matching operator delete found; memory will not be freed if initialization throws an exception'
       -wd4345 # Suppress 'behavior change: an object of POD type constructed with an initializer of the form () will be default-initialized'
       -wd4355 # Suppress ''this' : used in base member initializer list'
@@ -109,6 +111,9 @@
     -D_HAS_EXCEPTIONS=0
   )
 
+  # Enable bigobj support and sane C++ exception semantics.
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /EHsc")
+
   # Put project in solution folder
   set_target_properties(include-what-you-use
     PROPERTIES FOLDER "Clang executables"
@@ -156,13 +161,15 @@
   LLVMObject # BitReader, Core, Support
   LLVMBitReader # Core, Support
   LLVMCore # Support
-  LLVMSupport
+  LLVMSupport # Demangle
+  LLVMDemangle
 )
 
 # Platform dependencies.
 if( WIN32 )
   target_link_libraries(include-what-you-use
     shlwapi
+    version # For clangDriver's MSVCToolchain
   )
 elseif( UNIX )
   include(FindCurses)

=== debian/changelog ===
iwyu (4.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version updated to 4.0.0
  * bump llvm deps to 4.0

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 03 Aug 2017 11:10:20 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,16 @@
 Priority: extra
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 8.0.0), cmake, libclang-3.9-dev, llvm-3.9-dev,
+Build-Depends: debhelper (>= 10.0.0), cmake, libclang-4.0-dev, llvm-4.0-dev,
  help2man, libncurses5-dev, zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://include-what-you-use.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/iwyu/trunk/
 Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/iwyu/trunk/
 
 Package: iwyu
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, clang-3.5 | clang-3.6 | clang-3.7 | clang-3.8 | clang-3.9 | clang-4.0, python
+Depends: ${shlibs:Depends}, ${misc:Depends}, clang-3.5 | clang-3.6 | clang-3.7 | clang-3.8 | clang-3.9 | clang-4.0 | clang-5.0 | clang-6.0, python
 Description: Analyze #includes in C and C++ source files
  "Include what you use" means this: for every symbol (type, function variable,
  or macro) that you use in foo.cc, either foo.cc or foo.h should #include a .h

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 	dh $@ --buildsystem=cmake --builddirectory=$(TARGET_BUILD)
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-3.9/
+	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-4.0/
 
 
 override_dh_auto_build:

## iwyu 5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -160,7 +160,8 @@
   LLVMProfileData # Core, Support, Object
   LLVMObject # BitReader, Core, Support
   LLVMBitReader # Core, Support
-  LLVMCore # Support
+  LLVMCore # BinaryFormat, Support
+  LLVMBinaryFormat # Support
   LLVMSupport # Demangle
   LLVMDemangle
 )
@@ -173,9 +174,12 @@
   )
 elseif( UNIX )
   include(FindCurses)
+  include(FindBacktrace)
+
   target_link_libraries(include-what-you-use
     pthread
     z
+    ${Backtrace_LIBRARIES}
     ${CURSES_LIBRARIES}
     ${CMAKE_DL_LIBS}
   )

=== debian/changelog ===
iwyu (5.0-1) unstable; urgency=medium

  * New upstream release
  * Switch to llvm/clang 5
  * Add clang-7 as part of the options
  * Standards-Version updated to 4.1.3

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 07 Feb 2018 20:56:47 +0100

iwyu (4.0-2) unstable; urgency=medium

  * Cleanup the list of dependencies to add clang and remove
    old clang versionc
  * Standards-Version updated to 4.1.1
  * fix priority-extra-is-replaced-by-priority-optional

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 21 Nov 2017 12:03:26 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,19 @@
 Source: iwyu
 Section: devel
-Priority: extra
+Priority: optional
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 10.0.0), cmake, libclang-4.0-dev, llvm-4.0-dev,
+Build-Depends: debhelper (>= 10.0.0), cmake, libclang-5.0-dev, llvm-5.0-dev,
  help2man, libncurses5-dev, zlib1g-dev
-Standards-Version: 4.0.0
+Standards-Version: 4.1.3
 Homepage: http://include-what-you-use.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/iwyu/trunk/
 Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/iwyu/trunk/
 
 Package: iwyu
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, clang-3.5 | clang-3.6 | clang-3.7 | clang-3.8 | clang-3.9 | clang-4.0 | clang-5.0 | clang-6.0, python
+Depends: ${shlibs:Depends}, ${misc:Depends}, clang | clang-4.0 | clang-5.0 | clang-6.0 | clang-7,
+ python
 Description: Analyze #includes in C and C++ source files
  "Include what you use" means this: for every symbol (type, function variable,
  or macro) that you use in foo.cc, either foo.cc or foo.h should #include a .h

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 	dh $@ --buildsystem=cmake --builddirectory=$(TARGET_BUILD)
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-4.0/
+	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-5.0/
 
 
 override_dh_auto_build:

## iwyu 6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -125,6 +125,7 @@
 
 # Clang dependencies.
 target_link_libraries(include-what-you-use
+  PRIVATE
   clangFrontend
   clangSerialization
   clangDriver
@@ -139,6 +140,7 @@
 
 # LLVM dependencies.
 target_link_libraries(include-what-you-use
+  PRIVATE
   LLVMX86AsmParser # MC, MCParser, Support, X86CodeGen, X86Desc, X86Info
   LLVMX86CodeGen # Analysis, AsmPrinter, CodeGen, Core, MC, Support, Target, 
                  # X86AsmPrinter, X86Desc, X86Info, X86Utils
@@ -169,6 +171,7 @@
 # Platform dependencies.
 if( WIN32 )
   target_link_libraries(include-what-you-use
+    PRIVATE
     shlwapi
     version # For clangDriver's MSVCToolchain
   )
@@ -177,6 +180,7 @@
   include(FindBacktrace)
 
   target_link_libraries(include-what-you-use
+    PRIVATE
     pthread
     z
     ${Backtrace_LIBRARIES}

=== debian/changelog ===
iwyu (6.0-2) unstable; urgency=medium

  * Switch to llvm/clang 7
    - debian/patches/clang-7-build.diff needed
  * Standards-Version updated to 4.2.1
  * Fix space-in-std-shortname-in-dep5-copyright
  * Also ship a manpage for iwyu_tool
  * Refresh manpage for fix_include

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 23 Sep 2018 22:12:33 +0100

iwyu (6.0-1) unstable; urgency=medium

  * New upstream release
    - Switched to llvm/clang 6
  * Package moved to salsa & git

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 28 Apr 2018 10:20:19 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,17 @@
 Priority: optional
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 10.0.0), cmake, libclang-5.0-dev, llvm-5.0-dev,
+Build-Depends: debhelper (>= 10.0.0), cmake, libclang-7-dev, llvm-7-dev,
  help2man, libncurses5-dev, zlib1g-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.2.1
 Homepage: http://include-what-you-use.org/
-Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/iwyu/trunk/
-Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/iwyu/trunk/
+Vcs-Git: https://salsa.debian.org/pkg-llvm-team/iwyu.git
+Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/iwyu
 
 Package: iwyu
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, clang | clang-4.0 | clang-5.0 | clang-6.0 | clang-7,
+Depends: ${shlibs:Depends}, ${misc:Depends}, 
+ clang | clang-4.0 | clang-5.0 | clang-6.0 | clang-7 | clang-8,
  python
 Description: Analyze #includes in C and C++ source files
  "Include what you use" means this: for every symbol (type, function variable,

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 	dh $@ --buildsystem=cmake --builddirectory=$(TARGET_BUILD)
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-5.0/
+	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-7/
 
 
 override_dh_auto_build:

## iwyu 7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.3)

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  message(STATUS "IWYU: out-of-tree configuration")
  set(IWYU_IN_TREE OFF)
else()
  message(STATUS "IWYU: in-tree configuration")
  set(IWYU_IN_TREE ON)
endif()

if (NOT IWYU_IN_TREE)
  cmake_policy(SET CMP0048 NEW)
  project(include-what-you-use)

  find_package(LLVM CONFIG REQUIRED)
  find_package(Clang CONFIG REQUIRED)

  list(APPEND CMAKE_MODULE_PATH ${LLVM_DIR})
  include(AddLLVM)
  include(HandleLLVMOptions)
endif()

message(STATUS "IWYU: configuring for LLVM ${LLVM_VERSION}...")

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

add_definitions(${LLVM_DEFINITIONS})
include_directories(
  ${LLVM_INCLUDE_DIRS}
  ${CLANG_INCLUDE_DIRS}
  )

set(LLVM_LINK_COMPONENTS
  Option
  Support
  X86AsmParser
  X86Desc
  X86Info
  )

add_llvm_executable(include-what-you-use
  iwyu.cc
  iwyu_ast_util.cc
  iwyu_cache.cc
  iwyu_driver.cc
  iwyu_getopt.cc
  iwyu_globals.cc
  iwyu_include_picker.cc
  iwyu_lexer_utils.cc
  iwyu_location_util.cc
  iwyu_output.cc
  iwyu_path_util.cc
  iwyu_preprocessor.cc
  iwyu_verrs.cc
  )

if (IWYU_IN_TREE)
  # Add a dependency on clang-headers to ensure the builtin headers are
  # available when IWYU is executed from the build dir.
  # The clang-headers target is only available in in-tree builds.
  add_dependencies(include-what-you-use clang-headers)
endif()

if (MINGW)
  # Work around 'too many sections' error with MINGW/GCC
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wa,-mbig-obj")
endif()

if (MSVC)
  # Disable warnings for IWYU, and disable exceptions in MSVC's STL.
  add_definitions(
    -wd4722 # Suppress ''destructor'' : destructor never returns, potential memory leak
    -D_HAS_EXCEPTIONS=0
    )

  # Enable bigobj support and sane C++ exception semantics.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj /EHsc")

  # Put project in solution folder
  set_target_properties(include-what-you-use
    PROPERTIES FOLDER "Clang executables"
    )
endif()

target_link_libraries(include-what-you-use
  PRIVATE
  clangBasic
  clangLex
  clangAST
  clangSema
  clangFrontend
  clangDriver
  )

# Platform dependencies.
if (WIN32)
  target_link_libraries(include-what-you-use
    PRIVATE
    shlwapi  # For PathMatchSpecA
    )
endif()

# Pick up Git revision so we can report it in version information.
include(FindGit)
if (GIT_FOUND AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE IWYU_GIT_REV
    OUTPUT_STRIP_TRAILING_WHITESPACE)
else()
  message(STATUS "Warning: IWYU Git version info not found, DO NOT release "
                 "from this build tree!")
endif()
add_definitions(-DIWYU_GIT_REV="${IWYU_GIT_REV}")

# Install programs
install(TARGETS include-what-you-use RUNTIME DESTINATION bin)
install(PROGRAMS fix_includes.py iwyu_tool.py DESTINATION bin)

# Install mapping files
file(GLOB MAPPING_FILES *.imp)
install(FILES ${MAPPING_FILES} DESTINATION share/include-what-you-use)

=== debian/changelog ===
iwyu (7.0-3) unstable; urgency=medium

  * Link against latomic on armhf to workaround a FTBFS
    Thanks to Adrian Bunk (Closes: #918060)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 03 Jan 2019 16:01:39 +0100

iwyu (7.0-2) unstable; urgency=medium

  * chrpath -d was enough to be able to remove my bad workaround

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 27 Dec 2018 12:12:15 +0100

iwyu (7.0-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 27 Dec 2018 11:22:19 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 10.0.0), cmake, libclang-7-dev, llvm-7-dev,
- help2man, libncurses5-dev, zlib1g-dev
+Build-Depends: debhelper (>= 10.0.0), cmake, clang-7, libclang-7-dev,
+ llvm-7-dev, help2man, libncurses5-dev, zlib1g-dev, chrpath
+Build-Conflicts: llvm-5.0-dev, llvm-6.0-dev
 Standards-Version: 4.2.1
 Homepage: http://include-what-you-use.org/
 Vcs-Git: https://salsa.debian.org/pkg-llvm-team/iwyu.git
@@ -12,7 +13,7 @@
 
 Package: iwyu
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, 
+Depends: ${shlibs:Depends}, ${misc:Depends},
  clang | clang-4.0 | clang-5.0 | clang-6.0 | clang-7 | clang-8,
  python
 Description: Analyze #includes in C and C++ source files

=== debian/rules ===
--- 
+++ 
@@ -13,18 +13,25 @@
 	ADDITIONAL_CXX_FLAGS += -mxgot
 endif
 
+ifneq (,$(filter $(DEB_HOST_ARCH), armel))
+	export DEB_LDFLAGS_MAINT_APPEND = -latomic
+endif
+
 %:
 	dh $@ --buildsystem=cmake --builddirectory=$(TARGET_BUILD)
 
+
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-7/
+	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-7/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-7/
 
 
 override_dh_auto_build:
 	dh_auto_build
-	help2man --no-info --version-string "$(VERSION)" -n "Analyze #includes in C and C++ source files" $(TARGET_BUILD)/include-what-you-use > $(TARGET_BUILD)/include-what-you-use.1
+	help2man --no-info --version-string "$(VERSION)" -n "Analyze #includes in C and C++ source files" $(TARGET_BUILD)/bin/include-what-you-use > $(TARGET_BUILD)/include-what-you-use.1
 	cd $(TARGET_BUILD) && ln -s include-what-you-use.1 iwyu.1 && \
 	cp ../fix_includes.py fix_include
+	chrpath -d $(TARGET_BUILD)/bin/include-what-you-use
+
 
 override_dh_auto_install:
 	dh_auto_install
@@ -35,3 +42,4 @@
 
 override_dh_auto_clean:
 	rm -rf $(TARGET_BUILD)
+

=== debian/watch ===
version=3
https://github.com/include-what-you-use/include-what-you-use/tags .*/clang_(.*)\.tar\.gz

## iwyu 8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -90,6 +90,16 @@
   clangSema
   clangFrontend
   clangDriver
+
+  # Revision [1] in clang moved PCHContainerOperations from Frontend
+  # to Serialization, but this broke builds that set
+  # -DBUILD_SHARED_LIBS=on.  Revision [2] is a followup that works
+  # around the issue by adding an explicit dependency on Serialization
+  # wherever there was a dependency on Frontend.  Since we depend on
+  # Frontend, we need an explicit dependency on Serialization too.
+  # [1] https://llvm.org/viewvc/llvm-project?view=revision&revision=348907
+  # [2] https://llvm.org/viewvc/llvm-project?view=revision&revision=348915
+  clangSerialization
   )
 
 # Platform dependencies.

=== debian/changelog ===
iwyu (8.0-3build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:14:14 +0100

iwyu (8.0-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * Use secure URI in Homepage field.
  * Bump debhelper from old 10 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Rely on pre-initialized dpkg-architecture variables.

  [ Sylvestre Ledru ]
  * Move to llvm/clang 9 (instead of 8)
  * Move dep to python 3 (Closes: #945688)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 01 Jan 2020 13:51:01 +0100

iwyu (8.0-2) unstable; urgency=medium

  * Cherry-pick the upstream patch to address
    the struct issue (Closes: #929492)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 05 Nov 2019 11:52:50 +0100

iwyu (8.0-1) unstable; urgency=medium

  * Upload to unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 07 Jul 2019 09:58:08 +0200

iwyu (8.0-1~exp1) experimental; urgency=medium

  * New upstream release
  * Uses clang-8

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 28 Apr 2019 11:24:24 +0200

=== debian/control ===
--- 
+++ 
@@ -3,19 +3,19 @@
 Priority: optional
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: debhelper (>= 10.0.0), cmake, clang-7, libclang-7-dev,
- llvm-7-dev, help2man, libncurses5-dev, zlib1g-dev, chrpath
+Build-Depends: debhelper-compat (= 12), cmake, clang-9, libclang-9-dev,
+ llvm-9-dev, help2man, libncurses5-dev, zlib1g-dev, chrpath
 Build-Conflicts: llvm-5.0-dev, llvm-6.0-dev
 Standards-Version: 4.2.1
-Homepage: http://include-what-you-use.org/
+Homepage: https://include-what-you-use.org/
 Vcs-Git: https://salsa.debian.org/pkg-llvm-team/iwyu.git
 Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/iwyu
 
 Package: iwyu
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
- clang | clang-4.0 | clang-5.0 | clang-6.0 | clang-7 | clang-8,
- python
+ clang | clang-4.0 | clang-5.0 | clang-6.0 | clang-7 | clang-8 | clang-9 | clang-10,
+ python3
 Description: Analyze #includes in C and C++ source files
  "Include what you use" means this: for every symbol (type, function variable,
  or macro) that you use in foo.cc, either foo.cc or foo.h should #include a .h

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 TARGET_BUILD=iwyu-build
 VERSION=$(shell dpkg-parsechangelog |grep "^Version:"|sed -e "s|Version: \(.*\)|\1|")
-DEB_BUILD_ARCH?=$(shell dpkg-architecture -qDEB_BUILD_ARCH)
+include /usr/share/dpkg/architecture.mk
 ADDITIONAL_CXX_FLAGS=""
 
 ifneq (,$(filter $(DEB_BUILD_ARCH),mips64el))
@@ -22,7 +22,7 @@
 
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-7/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-7/
+	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(ADDITIONAL_CXX_FLAGS)" -DLLVM_PATH=/usr/lib/llvm-9/ -DCMAKE_PREFIX_PATH=/usr/lib/llvm-9/
 
 
 override_dh_auto_build:
@@ -42,4 +42,3 @@
 
 override_dh_auto_clean:
 	rm -rf $(TARGET_BUILD)
-
